    ; ***********************************************************************
    ; *
    ; *                P A C M A N      9 8
    ; *
    ; *           Programmed by Patrick Davidson
    ; *
    ; ***********************************************************************
NUM_LEVELS        =4
         .include "ti-86.h"
 ; -------------- PROGRAM HEADER --------------------------------------------
.define  RAND     ld de,(rptr) \ inc de \ res 7,d \ ld (rptr),de \ ld a,(de) \ xor e
 ; -------------- VARIABLE ADDRESSES ----------------------------------------
scrlstart         =$8100
scrlpos           =$8110
temp              =$8120

lives             =$b800
data              =$b802
x                 =$b8c2
y                 =$b8c3
xv                =$b8c4
yv                =$b8c5
level             =$b8c6
image             =$b8c7
pills             =$b8c9
enemies           =$b8ca
jp2nd             =$b8de
nxv               =$b8df
nyv               =$b8e0
countdown         =$b8e1
data_end          =$b8e2
score             =$b8e3
rptr              =$b8e5
 ; -------------- INITIALIZATION CODE ---------------------------------------
         ld       b,96
         ld       a,32
         ld       ix,$9000
pcl:     ld       hl,0
         ld       ($c00f),hl
         push     af
         push     bc
         call     _putc
         ld       hl,$fc00
         ld       b,8
         ld       de,16
il2:     ld       a,(hl)
         sla      a
         or       (hl)
         ld       (ix),a
         add      hl,de
         inc      ix
         djnz     il2
         pop      bc
         pop      af
         inc      a
         djnz     pcl
         call     display_ttl_scr
         ld       de,default_enemy_data
         ld       hl,500
         cp       K_F4
         jr       nz,nocheat
         ld       de,easy_enemy_data
         ld       hl,0
nocheat: ld       (enemy_setup+1),de
         ld       (score),hl

now:     jp       play_game
 ; -------------- TITLE SCREEN ----------------------------------------------
display_ttl_scr:
         call     _clrLCD
         ld       hl,0
         ld       ($c00f),hl
         ld       hl,title
         call     _puts
         ld       ix,$c00f
         inc      (ix)
         call     _puts
         inc      (ix)
         call     _puts
         ld       hl,0
         ld       (scrlpos),hl
         ld       hl,$0806
         ld       ($9300),hl
intro_loop:
         ld       hl,$9380
         ld       b,128
lclearscrl:
         ld       (hl),0
         inc      hl
         djnz     lclearscrl
         ld       hl,(scrlpos)
         inc      hl
         ld       de,(scrl_end-scrltext)*8
         call     CP_HL_DE
         jr       nz,okscrl
         ld       hl,0
okscrl:  ld       (scrlpos),hl
         ld       a,8
         call     UNPACKHL+2
         cpl
         and      7
         ld       de,scrltext
         add      hl,de
         ld       b,15
scroll_loop:
         push     bc
         push     hl
         push     af
         ld       a,(hl)
         sub      32
         ld       l,a
         ld       h,0
         add      hl,hl
         add      hl,hl
         add      hl,hl
         ld       de,$9000
         add      hl,de
         ld       de,$9302
         ld       bc,8
         ldir
         pop      af
         push     af
         ld       d,a
         ld       e,56
         ld       ix,$9300
         call     drw_spr
         pop      af
         pop      hl
         pop      bc
         add      a,8
         inc      hl
         djnz     scroll_loop
         ld       de,15
         ld       hl,$9380
         ld       b,8
         ld       a,255
loop_blox:
         ld       (hl),a
         add      hl,de
         ld       (hl),a
         inc      hl
         djnz     loop_blox
         dec      hl
         ld       de,$ffff
         ld       bc,128
         lddr

         call     GET_KEY
         or       a
         jr       z,intro_loop
         ret
title:   .db      "PacMan 98 Version 1.1",0
         .db      "by Patrick A Davidson"
         .db      "ariwsi@rocketmail.com",0
         .db      "   Copyright 1997",0
         .db      0
scrltext:.db      "                 "
         .db      "WELCOME TO PACMAN 98!  "
         .db      "PRESS THE F4 KEY TO START THE "
         .db      "GAME IN EASY MODE, OR ANY "
         .db      "OTHER KEY TO PLAY AT NORMAL "
         .db      "DIFFICULTY.  USE ARROW KEYS "
         .db      "TO PLAY, EXIT TO GIVE UP.  "
         .db      "PRESS 2nd TO TURN AUTOPILOT "
         .db      "ON OR OFF. "
         .db      " TEXT RESTARTS ...  "
scrl_end:.db      "                  "
 ; -------------- THE ACTUAL GAME -------------------------------------------
play_game:
         call     _clrLCD
         ld       hl,$1000
         ld       ($c00f),hl
         ld       hl,initialtemplate
         call     _puts
         ld       de,$1003
         ld       ($c00f),de
         call     _puts
         ld       de,$1006
         ld       ($c00f),de
         call     _puts
         LD       hl,lives
         ld       b,data_end-lives-1
         ld       (hl),9
cldl:    inc      hl
         ld       (hl),0
         djnz     cldl
         ld       a,1
         ld       (level),a
level_start:
         call     make_level
         call     prepare_to_play_level
main_loop:
         call     render_background
         call     do_you
         call     do_enemies
         call     display_stats
         call     display_data
         call     toggle_autopilot
         ld       a,(pills)
         or       a
         jr       z,you_won
         ld       a,%111111
         out      (1),a
         in       a,(1)
         sla      a
         ret      nc
         sla      a
         jr       c,main_loop
         ret
you_won: ld       hl,level
         inc      (hl)
         ld       b,100
         ld       a,(lives)
         ld       e,a
         ld       d,0
         ld       hl,(score)
loopis:  add      hl,de
         ld       (score),hl
         push     hl
         push     de
         push     bc
         call     display_stats
         pop      bc
         pop      de
         pop      hl
         djnz     loopis
         ld       a,(level)
         cp       NUM_LEVELS+1
         jr       z,win

         call     display_stats
         jr       level_start
win:     ld       hl,(score)
         ld       de,1000
         add      hl,de
         ld       (score),hl
         call     display_stats
         ld       b,3
loop_flickerw:
         push     bc
         call     display_data
         ld       bc,0
lww1:    dec      bc
         ld       a,b
         or       c
         jr       nz,lww1
         ld       hl,$0303
         ld       ($c00f),hl
         ld       hl,youwin
         call     _puts
         ld       bc,0
lww2:    dec      bc
         ld       a,b
         or       c
         jr       nz,lww2
         pop      bc
         djnz     loop_flickerw        
         ret
youwin:  .db      "YOU WIN!!!!",0
 ; -------------- DISPLAY STATUS INFORMATION --------------------------------
display_stats:
         ld       hl,$1001
         ld       ($c00f),hl
         ld       hl,(score)
         call     D_HL_DECI
         ld       hl,$1004
         ld       ($c00f),hl
         ld       a,(lives)
         ld       l,a
         ld       h,0
         call     D_HL_DECI
         ld       hl,$1007
         ld       ($c00f),hl
         ld       a,(level)
         ld       l,a
         ld       h,0
         call     D_HL_DECI
         ret
 ; -------------- RENDER THE BACKGROUND -------------------------------------
render_background:
         ld       ix,$a000
         ld       de,data
         ld       b,12
line_loop:
         push     bc
         ld       b,12
blocks_loop:
         push     bc
         ld       bc,block_images
         ld       a,(de)
         ld       l,a
         inc      de
         ld       h,0
         add      hl,hl
         add      hl,hl
         add      hl,hl
         add      hl,bc
         pop      bc
         ld       a,(hl)
         ld       (ix),a
         inc      hl
         ld       a,(hl)
         ld       (ix+12),a
         inc      hl
         ld       a,(hl)
         ld       (ix+24),a
         inc      hl
         ld       a,(hl)
         ld       (ix+36),a
         inc      hl
         ld       a,(hl)
         ld       (ix+48),a
         inc      hl
         ld       a,(hl)
         ld       (ix+60),a
         inc      hl
         ld       a,(hl)
         ld       (ix+72),a
         inc      hl
         ld       a,(hl)
         ld       (ix+84),a
         inc      ix
         djnz     blocks_loop
         ld       bc,84
         add      ix,bc
         pop      bc
         djnz     line_loop
         ret
 ; -------------- COPY THE IMAGE TO THE SCREEN ------------------------------
top_of_buffer:
         ld       de,384
         add      hl,de
         jr       dispi
display_data:
         ld       hl,$a000
         ld       a,(y)
         bit      6,a
         jr       nz,top_of_buffer
         sub      32
         jr       z,dispi
         jp       m,dispi
         ld       b,a
         ld       de,12
lfa:     add      hl,de
         djnz     lfa
dispi:   ld       de,$fc00
         ld       a,32
loop_copy_image:
         ld       bc,12
         ldir
         inc      de
         inc      de
         inc      de
         inc      de
         ld       bc,12
         ldir
         inc      de
         inc      de
         inc      de
         inc      de
         dec      a
         jp       nz,loop_copy_image
         ret
 ; -------------- SET UP A LEVEL --------------------------------------------
make_level:
         ld       de,144
         ld       hl,level_maps-144
         ld       a,(level)
         ld       b,a
lfld:    add      hl,de
         djnz     lfld
         ld       bc,144
         ld       de,data
         ld       b,144
         ld       c,0
loop_make_level_map:
         ld       a,(hl)
         bit      4,a
         jr       z,nph
         inc      c
nph:     ld       (de),A
         INC      HL
         INC      DE
         djnz     loop_make_level_map
         ld       a,c
         ld       (pills),a
         ret

prepare_to_play_level:
         call     render_background      
         call     display_stats
         ld       hl,image_right
         ld       (image),hl
         ld       hl,0
         ld       (x),hl
         ld       (xv),hl
         ld       (nxv),hl
         ld       a,$5f
         ld       (bitsmc+1),a
         ld       b,3
loop_flicker:
         push     bc
         call     display_data
         ld       bc,0
lw1:     dec      bc
         ld       a,b
         or       c
         jr       nz,lw1
         ld       hl,$0303
         ld       ($c00f),hl
         ld       hl,getready
         call     _puts
         ld       bc,0
lw2:     dec      bc
         ld       a,b
         or       c
         jr       nz,lw2
         pop      bc
         djnz     loop_flicker
         ld       de,enemies
enemy_setup:
         ld       hl,default_enemy_data
         ld       bc,20
         ldir
         ret
getready:.db      "GET READY!",0
default_enemy_data:
         .DB      3,40,40,0,0
         .DB      3,48,40,0,0
         .DB      3,40,48,0,0
         .DB      3,48,48,0,0       
easy_enemy_data:
         .DB      0,00,00,0,0
         .DB      3,48,40,0,0
         .DB      3,40,48,0,0
         .DB      3,48,48,0,0       
initialtemplate:
         .db      "SCORE",0
         .db      "LIVES",0
         .db      "LEVEL",0
 ; -------------- SPRITE RENDERING ROUTINE ----------------------------------
offsets_table:
         .db      128,64,32,16,8,4,2,1
drw_spr: ld       a,d
         and      7
         ld       hl,offsets_table
         ld       c,a
         ld       b,0
         add      hl,bc
         ld       a,(hl)
         ld       (smc1+1),a

         ld       hl,$9000          ;Calculate byte number
         ld       B,0
         ld       a,e
         add      a,a
         add      a,a
         add      a,a
         rl       b
         add      a,a
         rl       b
         srl      d
         srl      d
         srl      d
         or       d
         ld       c,a
         add      hl,bc                                    
          
         ld       d,(ix)       
         inc      ix
         ld       b,(ix)        
         inc      ix
oloop:   push     bc                ;Save # of rows
         push     hl                ;Save screen address
         ld       b,d               ;Load width
         ld       c,(ix)            ;Load one line of image
         inc      ix
smc1     ld       a,1               ;Load pixel mask
iloop:   sla      c                 ;Test leftmost pixel
         jr       nc,noplot         ;See if a plot is needed
         ld       e,a               ;OR pixel with screen
         or       (hl)
         ld       (hl),a
         ld       a,e
noplot:  rrca
         jr       nc,notedge        ;Test if edge of byte reached
         inc      hl                ;Go to next byte
notedge: djnz     iloop
         pop      hl                ;Restore address
         ld       bc,16             ;Go to next line
         add      hl,bc
         pop      bc                ;Restore data
         djnz     oloop
         ret
drw_spr96:
         ld       a,d
         and      7
         ld       hl,offsets_table
         ld       c,a
         ld       b,0
         add      hl,bc
         ld       a,(hl)
         ld       (_smc1+1),a

         ld       hl,$a000  ;Calculate byte number

         ld       B,0
         ld       a,e
         add      a,a
         add      a,e
         rl       b
         add      a,a
         rl       b
         add      a,a
         rl       b
         srl      d
         srl      d
         srl      d
         add      a,d
         jr       nc,n1
         inc      b
n1:      ld       c,a
         add      hl,bc                                    
          
         ld       d,(ix)       
         inc      ix
         ld       b,(ix)        
         inc      ix
_oloop:  push     bc                ;Save # of rows
         push     hl                ;Save screen address
         ld       b,d               ;Load width
         ld       c,(ix)            ;Load one line of image
         inc      ix
_smc1    ld       a,1               ;Load pixel mask
_iloop:  sla      c                 ;Test leftmost pixel
         jr       nc,_noplot        ;See if a plot is needed
         ld       e,a               ;OR pixel with screen
         or       (hl)
         ld       (hl),a
         ld       a,e
_noplot: rrca
         jr       nc,_notedge       ;Test if edge of byte reached
         inc      hl                ;Go to next byte
_notedge:djnz     _iloop
         pop      hl                ;Restore address
         ld       bc,12             ;Go to next line
         add      hl,bc
         pop      bc                ;Restore data
         djnz     _oloop
         ret
 ; -------------- LEVEL DATA ------------------------------------------------
level_maps:
         .db      03,21,21,17,17,21,21,17,17,21,21,25
         .db      26,35,21,28,26,19,25,26,22,21,41,26
         .db      26,26,35,17,20,28,22,20,17,41,26,26
         .db      18,28,26,26,19,17,17,25,26,26,22,24
         .db      18,21,24,26,26,10,10,26,26,18,21,24
         .db      26,19,28,18,28,10,10,22,24,22,25,26
         .db      26,22,25,18,25,10,10,19,24,19,28,26
         .db      18,21,24,26,26,10,10,26,26,18,21,24
         .db      18,25,26,26,22,20,20,28,26,26,19,24
         .db      26,26,38,20,17,25,19,17,20,44,26,26
         .db      26,38,21,25,26,22,28,26,19,21,44,26
         .db      22,21,21,20,20,21,21,20,20,21,21,28

         .db      03,21,21,17,17,41,35,17,17,21,21,25
         .db      26,19,21,28,26,26,26,26,22,21,25,26
         .db      26,26,19,21,28,26,26,22,21,25,26,26
         .db      18,28,26,19,21,16,16,21,25,26,22,24
         .db      18,21,28,26,19,24,18,25,26,22,21,24
         .db      38,21,21,24,26,14,14,26,18,21,21,44
         .db      35,21,21,24,26,11,11,26,18,21,21,41
         .db      18,21,25,26,22,24,18,28,26,19,21,24
         .db      18,25,26,22,21,16,16,21,28,26,19,24
         .db      26,26,22,21,25,26,26,19,21,28,26,26
         .db      26,22,21,25,26,26,26,26,19,21,28,26
         .db      22,21,21,20,20,44,38,20,20,21,21,28

         .db      03,21,21,21,21,17,17,21,21,21,21,25
         .db      26,35,17,21,21,28,22,21,21,17,41,26
         .db      26,26,18,21,21,21,21,21,21,24,26,26
         .db      26,26,18,21,17,25,19,17,21,24,26,26
         .db      26,26,26,19,28,26,26,22,25,26,26,26
         .db      18,28,26,26,19,12,06,25,26,26,22,24
         .db      18,25,26,26,22,09,03,28,26,26,19,24
         .db      26,26,26,22,25,26,26,19,28,26,26,26
         .DB      26,26,18,21,20,28,22,20,21,24,26,26
         .db      26,26,18,21,21,21,21,21,21,24,26,26
         .db      26,38,20,21,21,25,19,21,21,20,44,26
         .db      22,21,21,21,21,20,20,21,21,21,21,28

         .db      03,21,21,21,17,17,17,17,21,21,21,25
         .db      26,35,21,21,24,10,10,18,21,21,41,26
         .db      26,26,19,21,28,10,10,22,21,25,26,26
         .db      26,26,26,19,21,08,02,21,25,26,26,26
         .db      18,20,28,18,25,10,10,19,24,22,20,24
         .db      18,21,21,44,26,10,10,26,38,21,21,24
         .db      18,21,21,41,26,10,10,26,35,21,21,24
         .db      18,17,25,18,28,10,10,22,24,19,17,24
         .db      26,26,26,22,21,08,02,21,28,26,26,26
         .db      26,26,22,21,25,10,10,19,21,28,26,26
         .db      26,38,21,21,24,10,10,18,21,21,44,26
         .db      22,21,21,21,20,20,20,20,21,21,21,28

 ; -------------- BLOCK IMAGES ----------------------------------------------
block_images:
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000

         .db      %11111111
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000

         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000

         .db      %11111111
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000

         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %11111111

         .db      %11111111
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %11111111

         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %11111111

         .db      %11111111
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %11111111

         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001

         .db      %11111111
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001

         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001

         .db      %11111111
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001

         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %11111111

         .db      %11111111
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %11111111

         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %11111111

         .db      %11111111
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %11111111



         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00011000
         .db      %00011000
         .db      %00000000
         .db      %00000000
         .db      %00000000

         .db      %11111111
         .db      %00000000
         .db      %00000000
         .db      %00011000
         .db      %00011000
         .db      %00000000
         .db      %00000000
         .db      %00000000

         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10011000
         .db      %10011000
         .db      %10000000
         .db      %10000000
         .db      %10000000

         .db      %11111111
         .db      %10000000
         .db      %10000000
         .db      %10011000
         .db      %10011000
         .db      %10000000
         .db      %10000000
         .db      %10000000

         .db      %00000000
         .db      %00000000
         .db      %00000000
         .db      %00011000
         .db      %00011000
         .db      %00000000
         .db      %00000000
         .db      %11111111

         .db      %11111111
         .db      %00000000
         .db      %00000000
         .db      %00011000
         .db      %00011000
         .db      %00000000
         .db      %00000000
         .db      %11111111

         .db      %10000000
         .db      %10000000
         .db      %10000000
         .db      %10011000
         .db      %10011000
         .db      %10000000
         .db      %10000000
         .db      %11111111

         .db      %11111111
         .db      %10000000
         .db      %10000000
         .db      %10011000
         .db      %10011000
         .db      %10000000
         .db      %10000000
         .db      %11111111

         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00011001
         .db      %00011001
         .db      %00000001
         .db      %00000001
         .db      %00000001

         .db      %11111111
         .db      %00000001
         .db      %00000001
         .db      %00011001
         .db      %00011001
         .db      %00000001
         .db      %00000001
         .db      %00000001

         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10011001
         .db      %10011001
         .db      %10000001
         .db      %10000001
         .db      %10000001

         .db      %11111111
         .db      %10000001
         .db      %10000001
         .db      %10011001
         .db      %10011001
         .db      %10000001
         .db      %10000001
         .db      %10000001

         .db      %00000001
         .db      %00000001
         .db      %00000001
         .db      %00011001
         .db      %00011001
         .db      %00000001
         .db      %00000001
         .db      %11111111

         .db      %11111111
         .db      %00000001
         .db      %00000001
         .db      %00011001
         .db      %00011001
         .db      %00000001
         .db      %00000001
         .db      %11111111

         .db      %10000001
         .db      %10000001
         .db      %10000001
         .db      %10011001
         .db      %10011001
         .db      %10000001
         .db      %10000001
         .db      %11111111

         .db      %11111111
         .db      %10000001
         .db      %10000001
         .db      %10011001
         .db      %10011001
         .db      %10000001
         .db      %10000001
         .db      %11111111



         .db      %00000000
         .db      %00000000
         .db      %00011000
         .db      %00111100
         .db      %00111100
         .db      %00011000
         .db      %00000000
         .db      %00000000

         .db      %11111111
         .db      %00000000
         .db      %00011000
         .db      %00111100
         .db      %00111100
         .db      %00011000
         .db      %00000000
         .db      %00000000

         .db      %10000000
         .db      %10000000
         .db      %10011000
         .db      %10111100
         .db      %10111100
         .db      %10011000
         .db      %10000000
         .db      %10000000

         .db      %11111111
         .db      %10000000
         .db      %10011000
         .db      %10111100
         .db      %10111100
         .db      %10011000
         .db      %10000000
         .db      %10000000

         .db      %00000000
         .db      %00011000
         .db      %00111100
         .db      %00111100
         .db      %00011000
         .db      %00000000
         .db      %00000000
         .db      %11111111

         .db      %11111111
         .db      %00000000
         .db      %00011000
         .db      %00111100
         .db      %00111100
         .db      %00011000
         .db      %00000000
         .db      %11111111

         .db      %10000000
         .db      %10000000
         .db      %10011000
         .db      %10111100
         .db      %10111100
         .db      %10011000
         .db      %10000000
         .db      %11111111

         .db      %11111111
         .db      %10000000
         .db      %10011000
         .db      %10111100
         .db      %10111100
         .db      %10011000
         .db      %10000000
         .db      %11111111

         .db      %00000001
         .db      %00000001
         .db      %00011001
         .db      %00111101
         .db      %00111101
         .db      %00011001
         .db      %00000001
         .db      %00000001

         .db      %11111111
         .db      %00000001
         .db      %00011001
         .db      %00111101
         .db      %00111101
         .db      %00011001
         .db      %00000001
         .db      %00000001

         .db      %10000001
         .db      %10000001
         .db      %10011001
         .db      %10111101
         .db      %10111101
         .db      %10011001
         .db      %10000001
         .db      %10000001

         .db      %11111111
         .db      %10000001
         .db      %10011001
         .db      %10111101
         .db      %10111101
         .db      %10011001
         .db      %10000001
         .db      %10000001

         .db      %00000001
         .db      %00000001
         .db      %00011001
         .db      %00111101
         .db      %00111101
         .db      %00011001
         .db      %00000001
         .db      %11111111

         .db      %11111111
         .db      %00000001
         .db      %00011001
         .db      %00111101
         .db      %00111101
         .db      %00011001
         .db      %00000001
         .db      %11111111

         .db      %10000001
         .db      %10000001
         .db      %10011001
         .db      %10111101
         .db      %10111101
         .db      %10011001
         .db      %10000001
         .db      %11111111

         .db      %11111111
         .db      %10000001
         .db      %10011001
         .db      %10111101
         .db      %10111101
         .db      %10011001
         .db      %10000001
         .db      %11111111
 ; -------------- DO STUFF ABOUT YOU ----------------------------------------
do_you:
         ld       ix,(image)
         ld       hl,x
         ld       d,(hl)
         inc      hl
         ld       e,(hl)
         call     drw_spr96
         ld       hl,x
         ld       a,(hl)
         inc      hl
         inc      hl
         add      a,(hl)
         dec      hl
         dec      hl
         ld       (hl),a
         inc      hl
         ld       b,a
         ld       a,(hl)
         inc      hl
         inc      hl
         add      a,(hl)
         ld       (y),a
         or       b
         and      7
         jr       nz,read_arrows
 ; -------------- POSSIBLY CHANGE YOUR MOVEMENT ------------------------------
autop:   ld       a,0
         or       a
         jr       z,km_
         ld       hl,0
         ld       (nxv),hl
km_:
         call     read_arrows
         ld       hl,(nxv)
         ld       (xv),hl
         ld       hl,x
         ld       c,(hl)            ;C = X
         srl      c                 ;C = X / 2
         srl      c                 ;C = X / 4
         srl      c                 ;C = X / 8
         inc      hl                ;HL -> Y
         ld       a,(hl)            ;A = Y
         ld       b,a               ;B = Y
         srl      a                 ;A = Y / 2
         add      a,b               ;A = 12 * Y / 8
         add      a,c               ;A = (X / 8) + (12 * Y / 8)
         ld       hl,data           ;HL -> MAP
         ld       c,a               ;C = (X / 8) + (12 * Y / 8)
         ld       b,0               ;BC = (X / 8) + (12 * Y / 8)
         add      hl,bc             ;HL -> MAP + (X / 8) + (12 * Y / 8)
         ld       a,(hl)

         bit      4,a
         jr       z,nopill
         push     hl
         ld       hl,pills
         dec      (hl)
         ld       hl,(score)
         inc      hl
         ld       (score),hl
         pop      hl
nopill:  bit      5,a
         jr       z,nospill
         push     af
         push     hl
         ld       hl,enemies
         ld       de,5
         ld       B,4
lse:     ld       a,(hl)
         cp       3
         jr       nz,cste
         ld       (hl),6
cste:    add      hl,de
         djnz     lse
         ld       a,160
         ld       (countdown),a
         ld       hl,(score)
         add      hl,de
         ld       (score),hl
         pop      hl
         pop      af
         nop
nospill: and      15
         ld       (hl),a

bitsmc:  bit      3,a
         ret      z
         ld       hl,0
         ld       (xv),hl
         ret
read_arrows:
         LD       A,%1111110
         ld       ix,bitsmc+1
         OUT      (1),a
         in       a,(1)
         srl      a
         jr       c,no_down
         ld       hl,image_down
         ld       (image),hl
         ld       hl,$0100
         ld       (nxv),hl
         ld       (ix),$57
no_down: srl      a
         jr       c,no_left
         ld       hl,image_left
         ld       (image),hl
         ld       hl,$00ff
         ld       (nxv),hl
         ld       (ix),$4f
no_left: srl      a
         jr       c,no_right
         ld       hl,image_right
         ld       (image),hl
         ld       hl,$0001
         ld       (nxv),hl
         ld       (ix),$5f
no_right:srl      a
         ret      c
         ld       hl,image_up
         ld       (image),hl
         ld       hl,$ff00
         ld       (nxv),hl
         ld       (ix),$47
         ret

 ; -------------- IMAGES ----------------------------------------------------
image_right:
         .db      7,7
         .db      %00000000
         .db      %00111100
         .db      %01110110
         .db      %01111100
         .db      %01111000
         .db      %01111110
         .db      %00111100
image_up:
         .db      7,7
         .db      %00000000
         .db      %00100100
         .db      %01110110
         .db      %01011110
         .db      %01111110
         .db      %01111110
         .db      %00111100
image_left:
         .db      7,7
         .db      %00000000
         .db      %00111100
         .db      %01101110
         .db      %00111110
         .db      %00011110
         .db      %01111110
         .db      %00111100
image_down:
         .db      7,7
         .db      %00000000
         .db      %00111100
         .db      %01111110
         .db      %01111110
         .db      %01111010
         .db      %01101110
         .db      %00100100
image_ghost:
         .db      7,7
         .db      %00000000
         .db      %00111100
         .db      %01111110
         .db      %01111010
         .db      %01111110
         .db      %01111110
         .db      %01010100
image_ghost_scared:
         .db      7,7
         .db      %00000000
         .db      %00101000
         .db      %01010100
         .db      %00101010
         .db      %01010100
         .db      %00101010
         .db      %01010100
image_ghost_dead:
         .db      7,4
         .db      %01000100
         .db      %10101010
         .db      %10101010
         .db      %01000100
 ; -------------- TOGGLE AUTOPILOT ------------------------------------------
toggle_autopilot:
         ld       a,%111111
         out      (1),a
         ld       hl,jp2nd
         in       a,(1)
         bit      5,a
         jr       nz,notpressed
         ld       a,(hl)
         or       a
         ret      nz
         ld       a,(autop+1)
         cpl
         ld       (autop+1),a
         ret
notpressed:
         ld       (hl),0
         ret
 ; -------------- STUFF RELATED TO ENEMIES ----------------------------------
do_enemies:
         ld       a,(countdown)
         or       a
         jr       z,ncd
         dec      a
         ld       (countdown),a
ncd:     ld       hl,enemies
         ld       b,4
enemy_loop:
         push     bc
         push     hl
         ld       b,0
         ld       c,(hl)
         ld       ix,enemy_routine_table
         add      ix,bc
         jp       (ix)
eback:   pop      hl
         pop      bc
         ld       de,5
         add      hl,de
         djnz     enemy_loop
         ret
enemy_routine_table:
         jp       eback
         jp       enemy_normal
         jp       enemy_scared
         jp       enemy_dead_r
enemy_dead_l:
         inc      hl
         dec      (hl)
         jr       z,enemy_restore
enemy_draw:
         ld       d,(hl)
         inc      hl
         ld       e,(hl)
         ld       ix,image_ghost_dead
         call     drw_spr96
         jr       eback
enemy_dead_r:
         inc      hl
         inc      (hl)
         ld       a,(hl)         
         cp       88
         jr       z,enemy_restore
         jr       enemy_draw
enemy_restore:
         dec      hl
         ld       (hl),3
         jr       eback
 ; -------------- NORMAL ENEMY ---------------------------------------------
enemy_normal:
         inc      hl
         ld       a,(hl)
         inc      hl
         or       (hl)
         and      7
         scf
         call     z,enemy_pseudo_intelligence
         call     nc,change_enemy_related_stuff

         ld       a,(y)
         sub      (hl)
         dec      hl
         add      a,5
         jp       m,nocoll1
         cp       10
         jr       nc,nocoll1
         ld       a,(x)
         sub      (hl)
         add      a,5
         jp       m,nocoll1
         cp       10
         jr       nc,nocoll1
         inc      sp
         inc      sp
         inc      sp
         inc      sp
         inc      sp
         inc      sp
         ld       hl,lives
         dec      (hl)
         ret      z
         call     prepare_to_play_level
         jp       main_loop
nocoll1:
      
         ld       a,(hl)
         inc      hl
         inc      hl
         add      a,(Hl)
         dec      hl
         dec      hl
         ld       (hl),a
         ld       d,a
         inc      hl
         ld       a,(hl)
         inc      hl
         inc      hl
         add      a,(hl)
         dec      hl
         dec      hl
         ld       (hl),a
         ld       e,A
         ld       ix,image_ghost
         call     drw_spr96
         jp       eback
 ; -------------- SCARED ENEMY ---------------------------------------------
slow:    inc      hl
         ld       d,(hl)
         inc      hl
         ld       e,(Hl)
         jr       drawit         
btn:     ld       (hl),3
         jp       enemy_normal
enemy_scared:
         ld       a,(countdown)
         or       a
         jr       z,btn
         rra
         jr       nc,slow
         inc      hl
         ld       a,(hl)
         inc      hl
         or       (hl)
         and      7
         scf
         call     z,enemy_pseudo_intelligence_2
         call     nc,change_enemy_related_stuff

         ld       a,(y)
         sub      (hl)
         dec      hl
         add      a,5
         jp       m,nocoll2
         cp       10
         jr       nc,nocoll2
         ld       a,(x)
         sub      (hl)
         add      a,5
         jp       m,nocoll2
         cp       10
         jr       nc,nocoll2
         ld       a,(hl)
         dec      hl
         ld       (hl),12
         sub      44
         jp       p,ec1
         ld       (hl),9
ec1:     inc      hl
         inc      hl
         ld       a,(hl)
         and      %11111000
         ld       (hl),a
         inc      hl
         ld       (hl),0
         inc      hl
         ld       (hl),0
         ld       hl,(score)
         ld       de,50
         add      hl,de
         ld       (score),hl
         jp       eback
nocoll2:
                
         ld       a,(hl)
         inc      hl
         inc      hl
         add      a,(Hl)
         dec      hl
         dec      hl
         ld       (hl),a
         ld       d,a
         inc      hl
         ld       a,(hl)
         inc      hl
         inc      hl
         add      a,(hl)
         dec      hl
         dec      hl
         ld       (hl),a
         ld       e,A
drawit:
         ld       ix,image_ghost_scared
         call     drw_spr96
         jp       eback
 ; -------------- CHANGE ENEMY DIRECTION -----------------------------------
change_enemy_related_stuff:
         push     hl
         RAND
         and      3
         add      a,a
         ld       b,0
         ld       c,a
         ld       hl,enemy_dirs_table
         add      hl,bc
         jp       (hl)
enemy_dirs_table:
         jr       left
         jr       right
         jr       up
         ld       a,$57
         ld       bc,$0100
         jr       enemy_continue
left:    ld       a,$4f
         ld       bc,$00ff
         jr       enemy_continue
right:   ld       a,$5f
         ld       bc,1
         jr       enemy_continue
up:      ld       a,$47
         ld       bc,$ff00
enemy_continue:
         ld       hl,smcebit+1
         ld       (hl),a
         pop      hl
         inc      hl
         ld       (hl),c
         inc      hl
         ld       (hl),b
         dec      hl
         dec      hl

         ld       a,(hl)            ;A = Y
         push     hl
         dec      hl
         ld       c,(hl)            ;C = X
         srl      c                 ;C = X / 2
         srl      c                 ;C = X / 4
         srl      c                 ;C = X / 8
         ld       b,a               ;B = Y
         srl      a                 ;A = Y / 2
         add      a,b               ;A = 12 * Y / 8
         add      a,c               ;A = (X / 8) + (12 * Y / 8)
         ld       hl,data           ;HL -> MAP
         ld       c,a               ;C = (X / 8) + (12 * Y / 8)
         ld       b,0               ;BC = (X / 8) + (12 * Y / 8)
         add      hl,bc             ;HL -> MAP + (X / 8) + (12 * Y / 8)
         ld       a,(hl)
         pop      hl
         scf
smcebit: bit      0,a
         ret      z
         inc      hl
         ld       (hl),0
         inc      hl
         ld       (hl),0
         dec      hl
         dec      hl
         scf
         ccf
         ret
enemy_pseudo_intelligence:
         push     hl
         RAND
         rra
         jr       c,_updown
_leftright:
         dec      hl
         ld       a,(x)
         sub      (hl)
         jp       p,_right
_left:   ld       a,$4f
         ld       bc,$00ff
         jp       enemy_continue
_updown: ld       a,(y)
         sub      (hl)
         jp       m,_up
_down:   ld       a,$57
         ld       bc,$0100
         jp       enemy_continue

_right:  ld       a,$5f
         ld       bc,1
         jp       enemy_continue
_up:     ld       a,$47
         ld       bc,$ff00
         jp       enemy_continue
enemy_pseudo_intelligence_2:
         push     hl
         RAND
         rra
         jr       c,__updown
         dec      hl
         ld       a,(x)
         sub      (hl)
         jp       m,_right
         ld       a,$4f
         ld       bc,$00ff
         jp       enemy_continue
__updown:ld       a,(y)
         sub      (hl)
         jp       p,_up
         ld       a,$57
         ld       bc,$0100
         jp       enemy_continue
         .end
